
"""
Trait definitions in the 'auth' namespace.

Traits related to authentication and authorization.
"""

# WARNING: This file is auto-generated by openassetio-traitgen, do not edit.

from typing import Union

from openassetio import TraitsData


class BearerTokenTrait:
    """
    This trait holds an authentication token that the manager may pass
    to a back-end service.
    Usage: locale
    """
    kId = "openassetio-mediacreation:auth.BearerToken"

    def __init__(self, traitsData):
        """
        Construct this trait view, wrapping the given data.

        @param traitsData @fqref{TraitsData}} "TraitsData" The target
        data that holds/will hold the traits properties.
        """
        self.__data = traitsData

    def isImbued(self):
        """
        Checks whether the data this trait has been applied to
        actually has this trait.
        @return `True` if the underlying data has this trait, `False`
        otherwise.
        """
        return self.isImbuedTo(self.__data)

    @classmethod
    def isImbuedTo(cls, traitsData):
        """
        Checks whether the given data actually has this trait.
        @param traitsData: Data to check for trait.
        @return `True` if the underlying data has this trait, `False`
        otherwise.
        """
        return traitsData.hasTrait(cls.kId)

    def imbue(self):
        """
        Adds this trait to the held data.

        If the data already has this trait, it is a no-op.
        """
        self.__data.addTrait(self.kId)

    @classmethod
    def imbueTo(cls, traitsData):
        """
        Adds this trait to the provided data.

        If the data already has this trait, it is a no-op.
        """
        traitsData.addTrait(cls.kId)

    
    def setToken(self, token: str):
        """
        Sets the token property.

        Contents of the token.
        """
        if not isinstance(token, str):
            raise TypeError("token must be a 'str'.")
        self.__data.setTraitProperty(self.kId, "token", token)

    def getToken(self, defaultValue: str=None) -> Union[str, None]:
        """
        Gets the value of the token property or the supplied default.

        Contents of the token.
        """
        value = self.__data.getTraitProperty(self.kId, "token")
        if value is None:
            return defaultValue

        if not isinstance(value, str):
            if defaultValue is None:
                raise TypeError(f"Invalid stored value type: '{type(value).__name__}' should be 'str'.")
            return defaultValue
        return value
        
    

